# QBCaseWhen

## Overview

The `QBCaseWhen` class is a utility for defining `WHEN` conditions within an SQL `CASE` expression in a `QBSelect` query. It specifies the conditions that, when met, determine the result of the `CASE` expression.

The `then` method assigns the value to return when the specified `WHEN` condition is satisfied. This enables the construction of dynamic and complex conditional logic directly within SQL queries.

For more information about constructing and executing queries, refer to the [QBSelect](https://docs.servoy.com/reference/servoycore/dev-api/database-manager/qbselect) section of this documentation.

## Methods Summarized

| Type                                                               | Name                       | Summary                                                                                |
| ------------------------------------------------------------------ | -------------------------- | -------------------------------------------------------------------------------------- |
| [QBCase](/reference/servoycore/dev-api/database-manager/qbcase.md) | [then(value)](#then-value) | Set the return value to use when the condition of the searched case expression is met. |

## Methods Detailed

### then(value)

Set the return value to use when the condition of the searched case expression is met.

**Parameters**

* [Object](/reference/servoycore/dev-api/js-lib/object.md) **value** The value.

**Returns:** [QBCase](/reference/servoycore/dev-api/database-manager/qbcase.md) the parent \`QBCase\` object with the associated condition and value applied.

**Sample**

```js
var query = datasources.db.example_data.order_details.createSelect();

// case expressions can be added to the result of the query
	query.result.add(query.case.when(query.columns.quantity.ge(1000)).then('BIG').else('small'));

 // they can also be used in conditions
	query.where.add(query.case
		.when(query.columns.discount.gt(10)).then(50)
		.when(query.columns.quantity.le(20)).then(70)
		.else(100)
	.multiply(query.columns.unitprice).lt(10000));
```

***


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.servoy.com/reference/servoycore/dev-api/database-manager/qbcasewhen.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
